package com.hornettest.mdb;

import javax.ejb.ActivationConfigProperty;
import javax.ejb.EJBException;
import javax.ejb.MessageDriven;
import javax.ejb.TransactionAttribute;
import javax.ejb.TransactionAttributeType;
import javax.ejb.TransactionManagement;
import javax.ejb.TransactionManagementType;
import javax.jms.JMSException;
import javax.jms.Message;
import javax.jms.MessageListener;
import javax.jms.ObjectMessage;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.jboss.ejb3.annotation.ResourceAdapter;

import com.hornettest.entity.ReceivedMsg;
import com.hornettest.entity.SentMessage;

@MessageDriven(name = "SlowConsumerMDB",
        activationConfig =
              {
                 @ActivationConfigProperty(propertyName = "destinationType", propertyValue = "javax.jms.Queue"),
                 @ActivationConfigProperty(propertyName = "destination", propertyValue = "queue/slowConsumerQueue"),
                 @ActivationConfigProperty(propertyName = "maxSession", propertyValue = "10"),
                 @ActivationConfigProperty(propertyName = "acknowledgeMode", propertyValue = "Auto-acknowledge")
              })
@TransactionManagement(TransactionManagementType.CONTAINER)
@TransactionAttribute(TransactionAttributeType.REQUIRED)
@ResourceAdapter("hornetq-ra.rar")
public class SlowConsumerMDB implements MessageListener {


	@PersistenceContext(unitName="HornetTest")
	private EntityManager entityManager;
	
	
	private static final Log log = LogFactory.getLog(SlowConsumerMDB.class);
	@Override
	public void onMessage(Message arg0) {
		try {
			ObjectMessage objMsg = (ObjectMessage) arg0;
			log.debug("SlowConsumer Msg Received " + objMsg.getObject());
			SentMessage st = (SentMessage) objMsg.getObject();
			
			ReceivedMsg rm = new ReceivedMsg();
			rm.setId(st.getId());
			rm.setValue(st.getValue());
			
			entityManager.persist(rm);
			entityManager.flush();
			log.debug("sleeping for 1 second");			
			Thread.sleep(1000);
		} catch (JMSException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			throw new EJBException(e);
		}
		 catch (InterruptedException e) {
			// TODO Auto-generated catch block
			throw new EJBException(e);
		}
	}

}
